<template>
  <div>
    <p style="display: none">{{ donationCurrency }}</p>
    <Loading v-if="isLoadingComponent" message="Loading..." />
    <div class="qr-scanner-container" v-if="scanning">
      <p class="camera-error-message">{{ this.cameraErrorMessage }}</p>
      <qrcode-stream
        v-if="!cameraErrorMessage"
        @decode="onDecode"
        @init="onInit"
        :paused="!scanning"
        :camera="camera"
      />
      <b-button
        variant="primary"
        @click="hideScanner"
        class="cancel-scanner-btn"
        >Cancel</b-button
      >
    </div>
    <div id="general-swap-section" v-show="!scanning">
      <!-- {{ form }} -->
      <b-form @submit="onSubmit" @reset="onReset" v-if="shouldRender">
        <div class="input-group-container">
          <!-- INPUT LIST DROPDOWN -->
          <b-form-group id="exampleInputGroup1">
            <label>From</label>
            <v-select
              :options="availableInputTokens"
              label="title"
              placeholder="Please select an input currency"
              @input="onSelectInputCurrency"
              :value="form.inputCurrency"
              :clearable="false"
              :filter="filterToken"
            >
              <template slot="option" slot-scope="option">
                <img
                  v-if="option.src"
                  :src="option.src"
                  height="20px"
                  width="20px"
                />
                <img
                  v-else-if="option.title === 'ETH'"
                  src="../assets/eth-logo.png"
                  height="20px"
                  width="20px"
                />
                <img
                  v-else
                  src="../assets/default-token.png"
                  height="20px"
                  width="20px"
                />
                {{ option.fullname }}
              </template>
            </v-select>
          </b-form-group>
          <!-- INPUT AMOUNT -->
          <b-form-group prepend="@" class="input-form-group">
            <div class="amount-label-container">
              <label>Enter Input Amount</label>
              <div v-if="getAccount">
                <p class="current-balance">
                  {{ getBalance[form.inputCurrency || 'ETH'] || 0.0 }}
                  {{ form.inputCurrency || 'ETH' }}
                </p>
                <label class="use-all-funds" @click="useAllFunds"
                  >Use All Funds</label
                >
              </div>
            </div>
            <div class="input-field-container">
              <b-input-group>
                <b-form-input
                  id="inputValue"
                  type="text"
                  v-model="form.inputValue"
                  required
                  @keyup="onAmountChange"
                  @focus="onInputFocus"
                  autocomplete="off"
                ></b-form-input>
                <div class="input-group-append">
                  <span class="input-group-text">
                    <img
                      v-if="form.inputCurrency === 'ETH'"
                      src="../assets/eth-logo.png"
                      height="20px"
                      width="20px"
                    />
                    <img
                      v-else
                      :src="inputTokenLogo"
                      height="20px"
                      width="20px"
                    />
                  </span>
                </div>
              </b-input-group>

              <!-- <b-form-input
                id="inputValue"
                type="text"
                v-model="form.inputValue"
                required
                @keyup="onAmountChange"
                @focus="onInputFocus"
                autocomplete="off"
              />-->
              <button
                type="button"
                class="erase"
                @click="form.inputValue = ''"
              ></button>
            </div>
            <b-form-invalid-feedback
              v-if="form.inputValue"
              :state="validateinputValue && validateBalance && validateSlippage"
              >{{ inputErrorMessage }}</b-form-invalid-feedback
            >
          </b-form-group>

          <token-warning
            v-if="form.inputCurrency !== 'ETH'"
            :symbol="form.inputCurrency"
            :tokenAddress="form.inputTokenAddress"
          />
        </div>

        <font-awesome-icon
          icon="arrows-alt-v"
          size="2x"
          color="#fff"
          class="switch-input-output-icon"
          @click="switchInputOutput"
        />

        <div class="output-group-container">
          <!-- OUTPUT LIST DROPDOWN -->
          <b-form-group id="exampleInputGroup1">
            <label>To</label>
            <v-select
              :options="availableOutputTokens"
              label="title"
              placeholder="Please select an output currency"
              @input="onSelectOutputCurrency"
              :value="form.outputCurrency"
              :clearable="false"
              :filter="filterToken"
            >
              <template slot="option" slot-scope="option">
                <img
                  v-if="option.src"
                  :src="option.src"
                  height="20px"
                  width="20px"
                />
                <img
                  v-else-if="option.title === 'ETH'"
                  src="../assets/eth-logo.png"
                  height="20px"
                  width="20px"
                />
                <img
                  v-else
                  src="../assets/default-token.png"
                  height="20px"
                  width="20px"
                />
                {{ option.fullname }}
              </template>
            </v-select>
          </b-form-group>

          <!-- OUTPUT AMOUNT -->
          <b-form-group class="input-form-group">
            <label for>Enter Output Amount</label>
            <div class="input-field-container">
              <b-input-group>
                <b-form-input
                  id="inputValue"
                  type="text"
                  v-model="form.outputValue"
                  required
                  @keyup="onAmountChange"
                  @focus="onOutputFocus"
                  autocomplete="off"
                ></b-form-input>
                <div class="input-group-append">
                  <span class="input-group-text">
                    <img
                      v-if="form.outputCurrency === 'ETH'"
                      src="../assets/eth-logo.png"
                      height="20px"
                      width="20px"
                    />
                    <img
                      v-else
                      :src="outputTokenLogo"
                      height="20px"
                      width="20px"
                    />
                  </span>
                </div>
              </b-input-group>

              <!-- <b-form-input
                id="inputValue"
                type="text"
                v-model="form.outputValue"
                required
                @keyup="onAmountChange"
                @focus="onOutputFocus"
                autocomplete="off"
              />-->
              <button
                type="button"
                class="erase"
                @click="form.outputValue = ''"
              ></button>
            </div>
            <b-form-invalid-feedback
              v-if="form.outputValue.length > 0"
              :state="validateOutputAmount"
              >{{ outputErrorMessage }}</b-form-invalid-feedback
            >
          </b-form-group>

          <token-warning
            v-if="form.outputCurrency !== 'ETH'"
            :symbol="form.outputCurrency"
            :tokenAddress="form.outputTokenAddress"
          />
        </div>

        <div
          class="exchange-info-container"
          v-if="
            slippage &&
              exchangeRate &&
              validateinputValue &&
              validateOutputAmount
          "
        >
          <b-form-group v-if="form.inputCurrency !== null">
            <label for>Exchange Rate</label>
            <p>
              1 {{ form.inputCurrency }} = {{ exchangeRate.toFixed(5) }}
              {{ form.outputCurrency }}
            </p>
          </b-form-group>
          <b-form-group v-if="form.inputCurrency !== null">
            <label for>Slippage</label>
            <p>{{ slippage.toFixed(2) }} %</p>
          </b-form-group>
        </div>

        <b-form-group
          v-if="form.inputCurrency !== null"
          class="advanced-toggle-group"
        >
          <b-form-checkbox
            switch
            v-model="showAdvanced"
            name="check-button"
            class="show-advanced-label"
            >Show Advanced Settings</b-form-checkbox
          >
        </b-form-group>

        <b-form-group
          class="input-form-group"
          id="exampleInputGroup1"
          v-if="form.inputCurrency !== null && showAdvanced"
        >
          <label for>Receiver Address</label>
          <div id="address-qr-btn-container">
            <div class="input-field-container address-field-container">
              <b-form-input
                type="text"
                v-model="form.targetAddress"
                placeholder="Enter receiver address"
                :state="validateTargetAddress"
                :disabled="swapMode === 'donation_swap'"
              />
              <button
                type="button"
                class="erase"
                @click="form.targetAddress = ''"
                :disabled="swapMode === 'donation_swap'"
              ></button>
            </div>
            <b-button
              variant="primary"
              id="qr-toggle-btn"
              @click="toggleScanner"
              :disabled="swapMode === 'donation_swap'"
            >
              <font-awesome-icon icon="qrcode" size="2x" color="#fff" />
            </b-button>
          </div>
          <b-form-invalid-feedback
            v-if="form.targetAddress.length > 0"
            :state="validateTargetAddress"
            >Invalid Receiver Address</b-form-invalid-feedback
          >
        </b-form-group>
        <p id="bad-token-message" v-if="isBadToken">
          Warning not all tokens will work with Uniswap. Read
          <a
            target="_blank"
            href="https://www.reddit.com/r/UniSwap/comments/c0k63p/contract_not_working/"
            >this</a
          >
          and make sure that your token contract is compatible with Uniswap.
        </p>
        <b-form-group v-if="form.inputCurrency !== null && showAdvanced">
          <div class="amount-label-container">
            <label for="range-1">Gas Price: {{ gasPrice }} GWEI</label>
            <div>
              <label class="reset-gas-price" @click="resetGasPrice"
                >Reset Gas Price</label
              >
            </div>
          </div>
          <b-form-input
            type="range"
            id="range-1"
            v-model="gasPrice"
            min="2"
            max="30"
            @change="updateGasLimitAndTxFee"
          />
          <p class="message-in-swap-form">Estimated Tx Fee: {{ txFee }} ETH</p>
        </b-form-group>
        <b-form-group v-if="form.inputCurrency !== null && showAdvanced">
          <div
            class="amount-label-container"
            v-if="form.inputCurrency !== null && showAdvanced"
          >
            <label for="range-1">Gas Limit: {{ gasLimit }} gas</label>
            <div>
              <label class="reset-gas-price" @click="resetGasLimit"
                >Reset Gas Limit</label
              >
            </div>
          </div>
          <div class="input-field-container">
            <b-form-input
              type="text"
              v-model="gasLimit"
              required
              :state="validateGasLimit"
            />
            <button type="button" class="erase" @click="gasLimit = ''"></button>
          </div>
        </b-form-group>
        <b-form-group v-if="form.inputCurrency !== null && showAdvanced">
          <div
            class="amount-label-container"
            v-if="form.inputCurrency !== null && showAdvanced"
          >
            <label for="range-1">Allowed Additional Slippage ( % )</label>
            <div>
              <label class="reset-gas-price" @click="updateGasLimitAndTxFee"
                >Use Recommended</label
              >
            </div>
          </div>
          <div class="input-field-container">
            <b-form-input
              type="text"
              v-model="ALLOWED_SLIPPAGE_PERCENT"
              required
              :state="validateSlippage"
            />
            <button
              type="button"
              class="erase"
              @click="ALLOWED_SLIPPAGE_PERCENT = ''"
            ></button>
          </div>
          <p
            class="message-in-swap-form"
            v-if="
              form.outputCurrency && form.outputValue && ALLOWED_SLIPPAGE >= 0
            "
          >
            You will receive minimum
            {{ form.outputValue - form.outputValue * ALLOWED_SLIPPAGE }}
            {{ form.outputCurrency }}
          </p>
        </b-form-group>
        <!-- <p>{{this.form}}</p> -->
        <div class="submit-button-group">
          <b-button type="reset" variant="outline-dark">Reset</b-button>
          <b-button
            type="submit"
            v-if="getAccount"
            variant="primary"
            :disabled="false"
            >Swap Now</b-button
          >
          <b-button
            type="submit"
            v-else
            variant="primary"
            :disabled="shouldDisableSwapButton"
            >Start Swap</b-button
          >
        </div>
      </b-form>
      <b-button id="listToken" variant="primary" @click="showListToken"
        >List ERC-20 Token</b-button
      >

      <Donation />

      <!-- Success Modal -->
      <b-modal
        ref="success_modal_ref"
        id="unlock_request_modal"
        title="Transaction Submitted"
        :hide-footer="true"
        @hide="redirect"
      >
        <p>
          Your transaction is successfully submitted to Ethereum Network. Click
          link below to view your transaction on etherscan.io
        </p>
        <a
          id="txUrl"
          target="_blank"
          rel="noopener noreferrer"
          :href="`https://etherscan.io/tx/${txHash}`"
          >View tx on etherscan.io</a
        >
      </b-modal>
      <!-- Fail Modal -->
      <b-modal
        ref="failed_model_ref"
        id="unlock_request_modal"
        title="Transaction Failed"
        :hide-footer="true"
      >
        <p>
          <span v-html="failedErrorMessage"></span>
        </p>
      </b-modal>
      <!-- Unlock Request -->
      <b-modal
        ref="unlock_request_modal_ref"
        id="unlock_request_modal"
        title="Unlock Your Token"
        :hide-footer="true"
      >
        <b-form @submit="onUnlock" v-if="approvedStatus === false">
          <b-form-group id="exampleInputGroup1">
            <p>
              Please unlock your token to allow Wallet to spend. Recommended
              allowance is {{ form.inputCurrency }} amount to swap + extra 10% .
              If you intend to spend more {{ form.inputCurrency }} in the
              future, please fill in higer allowance so that you can avoid extra
              gas fees caused by future approval transactions
            </p>
            <label>{{ form.inputCurrency }} Amount to Unlock</label>
            <b-form-input type="text" v-model="form.approvedAmount" />
          </b-form-group>
          <b-button type="submit" variant="outline-primary">Approve</b-button>
        </b-form>
        <p v-else-if="approvedStatus === `waiting`">
          <span>
            <scale-loader
              :color="`#a41de4`"
              :height="`15px`"
              :width="`5px`"
            ></scale-loader>
          </span>
          Waiting for the approval transaction to be confirmed on Ethereum,
          before submitting swap transaction. It may take 1 to 3 minutes
          depending on network traffic and your transaction fee.
          <span v-if="approvedStatus === `waiting` && unlockTxHash">
            See status of your approval tx on
            <a
              id="txUrl"
              target="_blank"
              rel="noopener noreferrer"
              :href="`https://etherscan.io/tx/${unlockTxHash}`"
              >etherscan.io</a
            >
          </span>
        </p>
        <p v-else-if="approvedStatus === true">
          Your approval is confirmed on Ethereum Network!. You can now submit
          your original transaction to spend {{ form.inputValue }}
          {{ getActiveToken }} token.
        </p>
      </b-modal>

      <!-- Sign In Modal -->
      <b-modal
        ref="connect_modal_ref"
        id="signin_modal"
        title="Connect to your wallet"
        :hide-footer="true"
      >
        <div v-if="getAccount">
          <p>Your wallet is successfully connected.</p>
          <b-button
            type="button"
            variant="outline-primary"
            @click="hideConnectModal"
            >Go Back to Swap</b-button
          >
        </div>
        <Noaccount :callback="hideConnectModal" v-else />
      </b-modal>
    </div>

    <!-- LIST TOKEN MODAL -->
    <b-modal
      ref="list_token_modal"
      id="list_token_modal"
      title="List A Token"
      :hide-footer="true"
      @hidden="onHideModal"
    >
      <b-form @submit="onListToken">
        <b-alert
          v-if="errorMessage.length > 0"
          show
          fade
          variant="danger"
          v-html="errorMessage"
        ></b-alert>
        <!-- <b-alert v-if="errorMessage.length > 0" show fade variant="danger" v-html="errorMessage" >{{errorMessage}}</b-alert> -->
        <b-alert v-if="infoMessage.length > 0" show fade variant="info">{{
          infoMessage
        }}</b-alert>
        <b-form-group id="exampleInputGroup1">
          <label>Select Your Token</label>
          <!-- <b-input v-model="form.tokenAddress"></b-input> -->
          <v-select
            :options="listableTokenList"
            label="title"
            placeholder="Please select a token"
            v-model="listForm.selectedTokenToList"
            @input="onSelectTokenToList"
            :clearable="false"
          >
            <template slot="option" slot-scope="option">
              <img
                v-if="option.src"
                :src="option.src"
                height="20px"
                width="20px"
              />
              <img
                v-else-if="option.title === 'ETH'"
                src="../assets/eth-logo.png"
                height="20px"
                width="20px"
              />
              <img
                v-else
                src="../assets/default-token.png"
                height="20px"
                width="20px"
              />
              {{ option.title }}
            </template>
          </v-select>
        </b-form-group>
        <b-button type="submit" variant="primary" :disabled="loading"
          >List Token</b-button
        >
      </b-form>
    </b-modal>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import axios from 'axios'
import { exchangeABI, tokenABI, ERC20_ABI } from '../assets/js/abi'
import ScaleLoader from 'vue-spinner/src/ScaleLoader.vue'
import {
  getWeb3,
  estimateGas,
  initContracts,
  estimateGasForSwap,
  estimateGasPrice,
  sendToken,
  signAndSendETH,
  swapTokenToEth,
  unlockToken,
  swapEthToToken,
  swapTokenToToken,
  metamaskSwap,
  hasTokenUniswap,
  isValidAddress,
  unlockTokenMetamask,
  getWeb3Metamask,
  currency,
  getCurrentReserve,
  getETHToUSDPrice,
  submitTxIdToServer,
  getLatestBlock,
  exchangeContracts,
  getExchangeAddress,
  tokenContracts,
  queryServer
} from '../assets/js/utils'
import BigNumber from 'bignumber.js'
import Vue from 'vue'
import VueQrcodeReader from 'vue-qrcode-reader'
import Loading from '~/components/Loading.vue'
import Noaccount from '~/components/Noaccount.vue'
import Donation from '~/components/Donation.vue'
import TokenWarning from '~/components/TokenWarning.vue'
import Holder from './Holder'
import config from '../config'
const defaultCamera = {
  audio: false, // don't request microphone access
  video: {
    facingMode: { ideal: 'environment' }, // use rear camera if available
    width: { min: 360, ideal: 680, max: 1920 }, // constrain video width resolution
    height: { min: 240, ideal: 480, max: 1080 } // constrain video height resolution
  }
}
Vue.use(VueQrcodeReader)
// let exchangeContracts = {};
let tokenAddressess = {}
// let tokenContracts = {};
export default {
  components: {
    Loading,
    Holder,
    ScaleLoader,
    Noaccount,
    Donation,
    TokenWarning
  },
  props: {
    swapMode: {
      default: 'swap',
      type: String
    },
    donationCurrency: {
      default: 'ETH',
      type: String
    }
  },
  data () {
    return {
      web3: null,
      web3Metamask: null,
      ALLOWED_SLIPPAGE_PERCENT: 1,
      account: null,
      form: {
        inputCurrency: null,
        outputCurrency: null,
        inputTokenAddress: null,
        outputTokenAddress: null,
        inputValue: '',
        inputValueUsd: '',
        outputValue: '',
        approvedAmount: 0,
        targetAddress: ''
      },
      listForm: {
        tokenAddress: ''
      },
      isLoadingComponent: false,
      loading: false,
      showAdvanced: false,
      gasPrice: 6,
      gasLimit: 80000,
      defaultGasPrice: 6,
      defaultGasLimit: 80000,
      txFee: 0,
      exchangeRate: 0,
      slippage: 0,
      txHash: '',
      approvedStatus: '',
      lastEditedField: '',
      unlockTxHash: '',
      inputErrorMessage: 'Please input a valid amount',
      outputErrorMessage: 'Please input a valid amount',
      failedErrorMessage: 'Your transaction has failed.',
      errorMessage: '',
      infoMessage: '',
      slippage: null,
      isBuySelected: true,
      isSellSelected: false,
      scanning: false,
      camera: null,
      cameraErrorMessage: '',
      ethToUsd: null,
      connectChecker: null
    }
  },
  computed: {
    ...mapGetters({
      getAccount: 'account/getAccount',
      getTokenList: 'account/getTokenList',
      getPrice: 'account/getPrice',
      getAvailableTokenList: 'account/getAvailableTokenList',
      getBadTokenList: 'account/getBadTokenList',
      getAvailableTokenAddresses: 'account/getAvailableTokenAddresses',
      getAvailableExchangeAddresses: 'account/getAvailableExchangeAddresses',
      getActiveToken: 'getActiveToken',
      getActiveTokenAddress: 'getActiveTokenAddress',
      getCurrentView: 'getCurrentView',
      getBalance: 'account/getBalance',
      getConnection: 'getConnection',
      getServerStatus: 'getServerStatus',
      getSummary: 'getSummary',
      getAllTokenPrice: 'getAllTokenPrice',
      getOwnedTokenList: 'account/getOwnedTokenList',
      getSignIn: 'getSignIn'
    }),
    ALLOWED_SLIPPAGE: function () {
      if (this.ALLOWED_SLIPPAGE_PERCENT)
        return parseFloat(this.ALLOWED_SLIPPAGE_PERCENT) / 100
      else return 0
    },
    shouldRender: function () {
      return true
    },
    isBadToken: function () {
      let self = this
      if (self.getActiveToken === 'ETH') return false
      let token = this.getAvailableTokenList.find(
        t => t.symbol === self.getActiveToken
      )
      if (!token) return true
      let badToken = this.getBadTokenList.find(
        t => t.tokenAddress.toLowerCase() === token.tokenAddress.toLowerCase()
      )
      if (badToken) {
        console.log(`BAD TOKEN: ${badToken.tokenAddress}`)
        return badToken
      }
      return false
    },
    inputTokenLogo: function () {
      let self = this
      if (this.form.inputCurrency === 'ETH') return '/_nuxt/assets/eth-logo.png'
      if (!this.form.inputTokenAddress) return '../assets/default-token.png'
      let token = this.getAvailableTokenList.find(
        t =>
          t.tokenAddress.toLowerCase() ===
          self.form.inputTokenAddress.toLowerCase()
      )
      if (token) return token.logo
    },
    outputTokenLogo: function () {
      let self = this
      if (this.form.outputCurrency === 'ETH')
        return '/_nuxt/assets/eth-logo.png'
      if (!this.form.outputTokenAddress) return '../assets/default-token.png'
      let token = this.getAvailableTokenList.find(
        t =>
          t.tokenAddress.toLowerCase() ===
          self.form.outputTokenAddress.toLowerCase()
      )
      if (token) return token.logo
    },
    availableTokens: function () {
      let self = this
      let options = this.getAvailableTokenList
        .map(token => token.symbol)
        .sort()
        .map(symbol => {
          return {
            value: symbol,
            text: symbol
          }
        })
      options.unshift({ value: 'ETH', text: 'ETH' })
      options.unshift({ value: null, text: 'Please select currency' })
      return options
    },
    tokenList: function () {
      let options = this.getAvailableTokenList.map(token => {
        return {
          title: token.symbol,
          src: token.logo
        }
      })
      options.unshift({ title: 'ETH', src: null })
      return options
    },
    availableInputTokens: function () {
      let self = this
      let inputCurrency = this.form.inputCurrency
      let tokenList = this.getAvailableTokenList
        .map(token => {
          let summary = self.getSummary.find(t => t.token_id === token.id)
          return {
            ...token,
            liquidity: summary ? summary.liquidity : 0,
            price_last_10M: summary ? summary.price_last_10M : 0
          }
        })
        .filter(token => token.liquidity > 1)
        .sort((a, b) => {
          if (b.symbol > a.symbol) return -1
          else return 1
        })
        .map(token => {
          return {
            title: token.symbol,
            fullname: `${token.symbol} (${token.name})`,
            src: token.logo,
            tokenAddress: token.tokenAddress
          }
        })
      tokenList.unshift({
        title: 'ETH',
        fullname: 'Ether',
        src: null,
        tokenAddress: null
      })
      if (this.form.inputCurrency === null) return tokenList
      else return tokenList.filter(token => token.title !== inputCurrency)
    },
    availableOutputTokens () {
      let list = this.availableInputTokens.filter(
        token =>
          token.tokenAddress !== '0x89d24A6b4CcB1B6fAA2625fE562bDD9a23260359'
      )
      return list
    },
    listableTokenList: function () {
      let self = this
      let list = this.getTokenList
        .filter(symbol => symbol.split('_')[1] !== 'LIQUIDITY')
        .map(symbol => {
          let token = self.getAvailableTokenList.find(t => t.symbol === symbol)
          if (token)
            return {
              title: symbol,
              balance: self.getBalance[symbol],
              priceInUsd: token ? self.getPrice[token.tokenAddress] : 0,
              src: token ? token.logo : null
            }
          else
            return {
              title: symbol,
              balance: self.getBalance[symbol],
              priceInUsd: 0,
              src: null
            }
        })
        .filter(t => t !== null)
        .filter(t => t.balance > 0 && t.title !== self.form.outputCurrency)
        .filter(t => t.title.slice(0, 6) !== 'UNI-V1')
        .sort((a, b) => b.priceInUsd - a.priceInUsd)
      return list
    },
    swapType () {
      if (
        this.form.inputCurrency !== 'ETH' &&
        this.form.outputCurrency === 'ETH'
      )
        return 'TOKEN_TO_ETH'
      else if (
        this.form.inputCurrency === 'ETH' &&
        this.form.outputCurrency !== 'ETH'
      )
        return 'ETH_TO_TOKEN'
      else return 'TOKEN_TO_TOKEN'
    },
    validateGasLimit () {
      var reg = /^\d+$/
      if (!reg.test(this.gasLimit)) return false
      return !Number.isNaN(parseInt(this.gasLimit))
    },
    validateUsdAmount () {
      if (this.swapMode !== 'donation_swap') return true
      let amount = parseFloat(this.form.inputValueUsd * 1)
      const isNaN = Number.isNaN(amount)
      if (isNaN || amount <= 0) return false
      if (amount < 5) return false
      return true
    },
    validateinputValue () {
      let amount = parseFloat(this.form.inputValue * 1)
      const isNaN = Number.isNaN(amount)
      if (isNaN || amount <= 0) return false
      return true
    },
    validateOutputAmount () {
      const amount = parseFloat(this.form.outputValue * 1)
      return Number.isNaN(amount) === false && amount > 0
    },
    validateCurrency () {
      //   if (this.form.inputCurrency === null || this.form.outputCurrency === null)
      //     return false;
      //   if (this.form.inputCurrency === this.form.outputCurrency) return false;
      //   else return true;
      return true
    },
    validateBalance () {
      if (!this.validateinputValue) return false
      let amount = parseFloat(this.form.inputValue * 1)
      let txFee = this.txFee
      let ethBalance = parseFloat(this.getBalance['ETH'])

      if (this.form.inputCurrency === 'ETH') {
        if (!ethBalance) return true
        if (amount + txFee > ethBalance) {
          this.inputErrorMessage = 'Not enough ETH balance or transaction fee'
          return false
        }
      } else {
        let tokenBalance = parseFloat(this.getBalance[this.form.inputCurrency])
        if (!tokenBalance) return true
        if (amount > tokenBalance || txFee > ethBalance) {
          this.inputErrorMessage = 'Not enough token balance or transaction fee'
          return false
        }
      }
      return true
    },
    validateSlippage () {
      if (!this.ALLOWED_SLIPPAGE_PERCENT) return false
      if (parseFloat(this.ALLOWED_SLIPPAGE_PERCENT) <= 0) {
        console.log('Invalid Slippage Value provided')
        return false
      }
      if (parseFloat(this.ALLOWED_SLIPPAGE_PERCENT) > 3) {
        this.inputErrorMessage = 'Slippage is too high.'
        return false
      }
      return true
    },
    shouldDisableSwapButton () {
      return (
        this.loading ||
        !this.validateCurrency ||
        !this.validateinputValue ||
        !this.validateOutputAmount ||
        !this.validateBalance ||
        !this.validateSlippage ||
        !this.validateGasLimit ||
        !this.validateUsdAmount ||
        this.isBadToken
      )
    },
    validateTargetAddress () {
      return isValidAddress(this.form.targetAddress)
    },
    validateInputLiquidity () {
      let self = this
      if (this.form.inputCurrency === 'ETH') return true
      if (this.form.inputCurrency === null) return true
      return true
      if (
        !self.form.inputTokenAddress ||
        self.form.inputCurrency === self.getActiveToken
      ) {
        self.form.inputTokenAddress = self.getActiveTokenAddress.toLowerCase()
      }
      let token = this.getAvailableTokenList.find(
        t =>
          t.symbol === this.form.inputCurrency &&
          t.tokenAddress.toLowerCase() ===
            self.form.inputTokenAddress.toLowerCase()
      )
      if (!token) {
        console.log('No Input Token found.')
        return false
      }
      let summary = this.getSummary.find(s => s.token_id === token.id)
      if (!summary) {
        console.log('No Input Summary found.')
        return false
      }
      if (summary.liquidity > 0) return true
      else {
        console.log('Invalid input liquidity')
        return false
      }
    },
    validateOutputLiquidity () {
      let self = this
      return true
      if (this.form.outputCurrency === 'ETH') return true
      if (this.form.outputCurrency === null) return true
      // if (self.getActiveToken !== "ETH") {
      //   self.form.outputTokenAddress = self.getActiveTokenAddress.toLowerCase();
      // }
      // self.form.outputTokenAddress = self.form.outputTokenAddress.toLowerCase();
      let token = this.getAvailableTokenList.find(
        t =>
          t.symbol === this.form.outputCurrency &&
          t.tokenAddress.toLowerCase() ===
            self.form.outputTokenAddress.toLowerCase()
      )
      if (!token) {
        console.log('No Output Token found.')
        return false
      }
      let summary = this.getSummary.find(s => s.token_id === token.id)
      if (!summary) {
        console.log('No Output Summary found.')
        return false
      }
      if (summary.liquidity > 0) return true
      else {
        console.log('Invalid input liquidity')
        return false
      }
    },
    isLoadingWallet: function () {
      if (this.getSignIn && this.getOwnedTokenList.length === 0) return true
      else return false
    }
  },
  updated: function () {},
  errorCaptured: function (err, component, info) {
    console.log('Unexpected Error.')
  },
  mounted: async function () {
    let self = this
    let redirectTokenAddress = this.$route.query.token
    if (redirectTokenAddress) this.isLoadingComponent = true
    let initChecker = setInterval(() => {
      if (
        self.getAvailableTokenList.length > 0 &&
        Object.keys(exchangeContracts).length > 0
      ) {
        clearInterval(initChecker)
        if (redirectTokenAddress) {
          this.redirectToTokenInfo(redirectTokenAddress)
          setTimeout(() => {
            this.isLoadingComponent = false
            this.fillDefaultForm()
            this.init()
          }, 2000)
        } else {
          this.isLoadingComponent = false
          this.fillDefaultForm()
          this.init()
        }
      }
    }, 500)
    // this.web3 = await getWeb3()
    // this.web3Metamask = await getWeb3Metamask()
  },
  methods: {
    ...mapActions({
      updateActiveToken: 'updateActiveToken',
      updateActiveTokenAddress: 'updateActiveTokenAddress',
      addPendingTransaction: 'transaction/addPendingTransaction',
      updateActiveTab: 'updateActiveTab',
      updateActiveToken: 'updateActiveToken',
      updateCurrentView: 'updateCurrentView',
      updateChartInfo: 'updateChartInfo'
    }),
    redirectToTokenInfo (redirectTokenAddress) {
      console.log(`Redirecting to ${redirectTokenAddress}`)
      let self = this
      self.redirecting = true
      setTimeout(() => {
        try {
          let token = self.getAvailableTokenList.find(
            t =>
              t.tokenAddress.toLowerCase() ===
              redirectTokenAddress.toLowerCase()
          )
          self.updateActiveToken(token.symbol)
          self.updateActiveTokenAddress(token.tokenAddress || '')
          self.updateActiveTab('exchange')
          self.updateCurrentView('tokeninfo')
          self.updateChartInfo({
            currency: 'USD',
            showChart: true,
            tokenAddress: redirectTokenAddress,
            tokenName: token.symbol
          })
          self.redirecting = false
        } catch (e) {
          console.log(e)
          alert('Invalid Token Address !')
          self.redirecting = false
        }
      }, 1500)
    },
    fillDefaultForm () {
      this.form.inputCurrency = 'ETH'
      this.form.outputCurrency = 'DAI'
      this.form.outputTokenAddress = '0x6B175474E89094C44Da98b954EedeAC495271d0F'.toLowerCase()
      this.form.inputValue = 1
      this.lastEditedField = 'input'
      this.onAmountChange()
    },
    filterToken (options, search) {
      return options.filter(option => {
        return option.fullname.toLowerCase().indexOf(search.toLowerCase()) > -1
      })
    },
    async init () {
      let self = this
      console.log('Initiating general swap form...')
      this.web3 = await getWeb3()
      this.web3Metamask = await getWeb3Metamask()
      try {
        let estimatedGasPriceFromNetwork = await estimateGasPrice(this.web3)
        this.gasPrice =
          parseInt(estimatedGasPriceFromNetwork / Math.pow(10, 9)) + 3
        this.defaultGasPrice = this.gasPrice
        await this.updateGasLimitAndTxFee()
      } catch (e) {
        console.log('Unable to estimate gas.')
      }
      this.ethToUsd = await getETHToUSDPrice()
      this.$root.$on('bv::modal::hide', (bvEvent, modalId) => {
        if (modalId === 'connect_modal_ref') {
          console.log('Connect Modal hide event detected')
          clearInterval(self.connectChecker)
          self.connectChecker = null
        }
      })
    },
    prepareForDonationSwap () {
      this.form.inputCurrency = this.donationCurrency
      this.form.outputCurrency = 'ULT'
      this.isBuySelected = true
      this.isSellSelected = false
      this.form.targetAddress = '0x19caf17b4ea9f8dd9b5e8f17ab0c3c10f132691d'
    },
    getDecimal (tokenAddress) {
      if (!tokenAddress) return 18
      let token = this.getAvailableTokenList.find(
        t => t.tokenAddress.toLowerCase() === tokenAddress.toLowerCase()
      )
      if (token) return token.decimal
      else return 18
    },
    async calculateAbsPrice (symbol, tokenAddress) {
      try {
        let { ethReserve, tokenReserve } = await getCurrentReserve(
          tokenAddress,
          this.web3
        )
        let decimal = this.getDecimal(tokenAddress)
        let absPrice =
          ethReserve / Math.pow(10, 18) / (tokenReserve / Math.pow(10, decimal))
        return absPrice
      } catch (e) {}
    },
    onSelectTokenToList () {
      let self = this
      let foundToken = this.getOwnedTokenList.find(
        t => t.symbol === self.listForm.selectedTokenToList.title
      )
      this.listForm.tokenAddress = foundToken.tokenAddress.toLowerCase()
    },
    onHideModal () {},
    onSelectInputCurrency (value) {
      if (!value) return
      this.form.inputCurrency = value.title
      if (value.tokenAddress)
        this.form.inputTokenAddress = value.tokenAddress
          ? value.tokenAddress.toLowerCase()
          : null

      this.ensureContractExist(
        this.form.inputCurrency,
        this.form.inputTokenAddress
      )
      this.onCurrencyChange()
    },
    async ensureContractExist (currency, tokenAddress) {
      if (currency === 'ETH') return
      let isExchangeContractExist = exchangeContracts[tokenAddress]
      if (isExchangeContractExist) {
        console.log(`Exchange contract is deteced for ${currency}`)
      } else {
        console.warn(`No Exchange contract deteced for ${currency}`)
        console.warn(`Initializing contract for ${currency}`)
        let token = this.getAvailableTokenList.find(
          t => t.tokenAddress.toLowerCase() === tokenAddress
        )
        if (!this.web3) this.web3 = await getWeb3()
        if (token) initContracts(this.web3, [token])
      }
    },
    onSelectOutputCurrency (value) {
      if (!value) return
      this.form.outputCurrency = value.title
      this.form.outputTokenAddress = value.tokenAddress
        ? value.tokenAddress.toLowerCase()
        : null
      this.ensureContractExist(
        this.form.outputCurrency,
        this.form.outputTokenAddress
      )
      this.onCurrencyChange()
    },
    showListToken () {
      if (this.getSignIn) this.showModal('list_token_modal')
      else this.showSignInModal()
    },
    async showSuccessToast (txHash) {
      // let successHTML
      // if (this.swapMode === 'donation_swap')
      //   successHTML = `<p>Thank you for your donation !</p>`
      // else
      //   successHTML = `<p>Your transaction is submitted to Ethereum Network.</p>`
      // this.$toasted.show(successHTML, {
      //   theme: 'outline',
      //   type: 'success',
      //   position: 'top-center',
      //   duration: 10000,
      //   fullWidth: true,
      //   action: [
      //     {
      //       text: 'View it On etherscan.io',
      //       onClick: (e, toastObject) => {
      //         toastObject.goAway(0)
      //         window.open(`https://etherscan.io/tx/${txHash}`, '_blank')
      //       }
      //     }
      //   ]
      // })
      const tx = await this.web3.eth.getTransaction(txHash)
      const nonce = tx.nonce
      if (txHash && nonce) {
        this.addPendingTransaction({ hash: txHash, nonce: nonce })
      }
      submitTxIdToServer(txHash)
    },
    showScanner () {
      this.scanning = true
      this.camera = defaultCamera
    },
    hideScanner () {
      this.scanning = false
      this.camera = null
    },
    toggleScanner () {
      if (this.scanning) this.hideScanner()
      else this.showScanner()
    },
    redirect () {
      this.$router.push('/tokendetail')
    },
    async useAllFunds () {
      if (this.form.inputCurrency === 'ETH') {
        this.form.inputValue = parseFloat(this.getBalance['ETH']) - this.txFee
      } else {
        this.form.inputValue = parseFloat(
          this.getBalance[this.form.inputCurrency]
        )
      }
      this.lastEditedField = 'input'
      this.onAmountChange()
    },
    async resetGasLimit () {
      this.gasLimit = this.defaultGasLimit
      this.updateGasLimitAndTxFee()
    },
    async resetGasPrice () {
      this.gasPrice = this.defaultGasPrice
      this.updateGasLimitAndTxFee()
    },
    resetMessages () {
      this.infoMessage = ''
      this.errorMessage = ''
    },
    async getEstimatedGas (toAddress) {
      try {
        let value = this.form.inputValue || 1
        let estimatedGas = await estimateGasForSwap(
          {
            // from: this.getAccount.address,
            to: toAddress,
            amount: new BigNumber(
              value * Math.pow(10, this.getDecimal(this.getActiveTokenAddress))
            ).toFixed()
          },
          this.web3,
          toAddress
        )
        return estimatedGas
      } catch (e) {
        console.warn('Unable to estimate gas')
      }
    },
    async updateGasLimitAndTxFee () {
      let self = this
      let outputCurrency = this.form.outputCurrency
      let outputValue = this.form.outputValue
      this.txFee =
        (2.0 * this.gasLimit * this.gasPrice * 1000000000) / Math.pow(10, 18)
      if (!outputValue) return
      let slippageInEth = this.txFee * 2
      if (outputCurrency !== 'ETH') {
        let token = this.getAvailableTokenList.find(
          t =>
            t.symbol === outputCurrency &&
            t.tokenAddress.toLowerCase() ===
              self.form.outputTokenAddress.toLowerCase()
        )
        let summary = this.getSummary.find(s => s.token_id === token.id)
        if (!summary) return
        let tokenPriceInEth = summary.price_last_10M
        let slippageInToken = slippageInEth / tokenPriceInEth
        this.ALLOWED_SLIPPAGE_PERCENT = (
          (slippageInToken / outputValue) *
          100
        ).toFixed(3)
        if (this.ALLOWED_SLIPPAGE_PERCENT > 3) this.ALLOWED_SLIPPAGE_PERCENT = 3
      } else {
        this.ALLOWED_SLIPPAGE_PERCENT = (
          (slippageInEth / outputValue) *
          100
        ).toFixed(3)
        if (this.ALLOWED_SLIPPAGE_PERCENT > 3) this.ALLOWED_SLIPPAGE_PERCENT = 3
      }
    },
    onDecode (decodedString) {
      this.form.targetAddress = decodedString
      this.hideScanner()
    },
    async onInit (promise) {
      try {
        await promise
      } catch (error) {
        console.log(error)
        if (error.name === 'NotAllowedError') {
          this.cameraErrorMessage =
            'ERROR: you need to grant camera access permisson'
        } else if (error.name === 'NotFoundError') {
          this.cameraErrorMessage = 'ERROR: no camera on this device'
        } else if (error.name === 'NotSupportedError') {
          this.cameraErrorMessage =
            'ERROR: secure context required (HTTPS, localhost)'
        } else if (error.name === 'NotReadableError') {
          this.cameraErrorMessage = 'ERROR: is the camera already in use?'
        } else if (error.name === 'OverconstrainedError') {
          this.cameraErrorMessage = 'ERROR: installed cameras are not suitable'
        } else if (error.name === 'StreamApiNotSupportedError') {
          this.cameraErrorMessage =
            'ERROR: Stream API is not supported in this browser'
        }
      }
    },
    onInputFocus () {
      this.lastEditedField = 'input'
    },
    onOutputFocus () {
      this.lastEditedField = 'output'
    },
    async onCurrencyChange () {
      if (!this.validateCurrency) return
      try {
        this.onAmountChange()
        if (this.form.inputCurrency === 'ETH') {
          const contractAddress = this.getAvailableExchangeAddresses[
            this.form.outputTokenAddress
          ]
          let estimatedGas = await this.getEstimatedGas(contractAddress)
          if (estimatedGas * 1.6 > this.gasLimit)
            this.gasLimit = parseInt(estimatedGas * 1.6)
          if (
            this.swapType === 'TOKEN_TO_TOKEN' &&
            this.gasLimit < estimatedGas * 2.5
          )
            this.gasLimit = parseInt(estimatedGas * 2.5)
        } else {
          const contractAddress = this.getAvailableExchangeAddresses[
            this.form.inputTokenAddress
          ]
          let estimatedGas = await this.getEstimatedGas(contractAddress)
          if (estimatedGas * 1.6 > this.gasLimit)
            this.gasLimit = parseInt(estimatedGas * 1.6)
          if (
            this.swapType === 'TOKEN_TO_TOKEN' &&
            this.gasLimit < estimatedGas * 2.5
          )
            this.gasLimit = parseInt(estimatedGas * 2.5)
        }
        this.defaultGasLimit = this.gasLimit
      } catch (e) {
        console.log('some error')
        console.log(e)
      }
    },
    async onAmountChange () {
      try {
        if (!this.form.inputCurrency || !this.form.outputCurrency) return
        if (this.lastEditedField === 'input') {
          if (!this.validateinputValue) {
            this.form.outputValue = ''
            return
          }
          this.updateUsdAmount()
          if (this.swapType === 'TOKEN_TO_ETH') {
            let exchangeContract =
              exchangeContracts[this.form.inputTokenAddress]
            let tokenSold = new BigNumber(
              this.form.inputValue *
                Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            ).toFixed(0)
            let ethBought = await exchangeContract.methods
              .getTokenToEthInputPrice(tokenSold)
              .call()
            this.form.outputValue = parseFloat(ethBought / Math.pow(10, 18))
          } else if (this.swapType === 'ETH_TO_TOKEN') {
            let exchangeContract =
              exchangeContracts[this.form.outputTokenAddress]
            let ethSold = new BigNumber(
              this.form.inputValue * Math.pow(10, 18)
            ).toFixed(0)
            let tokenBought = await exchangeContract.methods
              .getEthToTokenInputPrice(ethSold)
              .call()
            this.form.outputValue = parseFloat(
              tokenBought /
                Math.pow(10, this.getDecimal(this.form.outputTokenAddress))
            )
          } else if (this.swapType === 'TOKEN_TO_TOKEN') {
            let exchangeContractA =
              exchangeContracts[this.form.inputTokenAddress]
            let tokenSoldA = new BigNumber(
              this.form.inputValue *
                Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            ).toFixed(0)
            let ethBought = await exchangeContractA.methods
              .getTokenToEthInputPrice(tokenSoldA)
              .call()
            let ethSold = ethBought
            let exchangeContractB =
              exchangeContracts[this.form.outputTokenAddress]
            let tokenBoughtB = await exchangeContractB.methods
              .getEthToTokenInputPrice(ethSold)
              .call()
            this.form.outputValue = parseFloat(
              tokenBoughtB /
                Math.pow(10, this.getDecimal(this.form.outputTokenAddress))
            )
          }
        } else if (this.lastEditedField === 'output') {
          if (!this.validateOutputAmount) {
            this.form.inputValue = ''
            return
          }
          if (this.swapType === 'TOKEN_TO_ETH') {
            let exchangeContract =
              exchangeContracts[this.form.inputTokenAddress]
            let ethBought = new BigNumber(
              this.form.outputValue * Math.pow(10, 18)
            ).toFixed(0)
            let tokenSold = await exchangeContract.methods
              .getTokenToEthOutputPrice(ethBought)
              .call()
            this.form.inputValue = parseFloat(
              tokenSold /
                Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            )
          } else if (this.swapType === 'ETH_TO_TOKEN') {
            let exchangeContract =
              exchangeContracts[this.form.outputTokenAddress]
            let tokenBought = new BigNumber(
              this.form.outputValue *
                Math.pow(10, this.getDecimal(this.form.outputTokenAddress))
            ).toFixed(0)
            let ethSold = await exchangeContract.methods
              .getEthToTokenOutputPrice(tokenBought)
              .call()
            this.form.inputValue = parseFloat(ethSold / Math.pow(10, 18))
          } else if (this.swapType === 'TOKEN_TO_TOKEN') {
            let exchangeContractB =
              exchangeContracts[this.form.outputTokenAddress]
            let tokenSoldB = new BigNumber(
              this.form.outputValue *
                Math.pow(10, this.getDecimal(this.form.outputTokenAddress))
            ).toFixed(0)
            let ethBought = await exchangeContractB.methods
              .getTokenToEthInputPrice(tokenSoldB)
              .call()

            let ethSold = ethBought
            let exchangeContractA =
              exchangeContracts[this.form.inputTokenAddress]
            let tokenBoughtA = await exchangeContractA.methods
              .getEthToTokenInputPrice(ethSold)
              .call()
            this.form.inputValue = parseFloat(
              tokenBoughtA /
                Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            )
          }
        }
        this.updateExchangeRateAndSlippage()
        this.updateGasLimitAndTxFee()
      } catch (e) {
        // let exchangeContractB = exchangeContracts[this.form.outputTokenAddress]
        console.warn(`Error during on amount change`, e)
      }
    },
    async onUnlock (evt) {
      evt.preventDefault()
      let txHash
      if (!this.getConnection) {
        alert('No Internet Connection Detected !')
        return
      }
      if (!this.getServerStatus) {
        alert('Connection Issue to Server !')
        return
      }
      let approvedAmount
      if (
        parseFloat(this.form.approvedAmount) >
        this.getBalance[this.form.inputCurrency]
      ) {
        approvedAmount = new BigNumber(
          this.getBalance[this.form.inputCurrency] *
            Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
        )
      } else {
        approvedAmount = new BigNumber(
          this.form.approvedAmount *
            Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
        )
      }
      this.approvedStatus = 'waiting'
      if (this.getAccount.type === 'metamask') {
        try {
          this.unlockTxHash = await unlockTokenMetamask(
            {
              from: this.getAccount.address,
              approvedAmount: approvedAmount.toFixed(0),
              gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
              gasLimit: parseInt(this.gasLimit)
            },
            this.form.inputTokenAddress,
            {
              web3: this.web3Metamask,
              exchangeAddress: this.getAvailableExchangeAddresses[
                this.form.inputTokenAddress
              ],
              privateKey: this.getAccount.privateKey
            }
          )
          console.log(`Unlock Tx Hash: ${this.unlockTxHash}`)
        } catch (e) {
          alert(
            'Your approval transaction has failed. Please try again to approve token to spend.'
          )
          this.hideModal('unlock_request_modal_ref')
        }
      } else {
        try {
          console.log(`approve: ${approvedAmount.toFixed(0)}`)
          this.unlockTxHash = await unlockToken(
            {
              from: this.getAccount.address,
              approvedAmount: approvedAmount.toFixed(0),
              gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
              gasLimit: parseInt(this.gasLimit)
            },
            this.form.inputCurrency,
            {
              web3: this.web3,
              exchangeAddress: this.getAvailableExchangeAddresses[
                this.form.inputTokenAddress
              ],
              privateKey: this.getAccount.privateKey
            }
          )
          console.log(`Unlock Tx Hash: ${this.unlockTxHash}`)
        } catch (e) {
          alert(
            'Your approval transaction has failed. Please try again to approve token to spend.'
          )
          this.hideModal('unlock_request_modal_ref')
        }
      }
      // checking allowance
      let self = this
      let check = setInterval(async () => {
        console.log('Checking allowance...')
        const allowance = await self.getAllowance(
          self.form.inputCurrency,
          self.form.inputTokenAddress
        )
        const required = new BigNumber(
          self.form.approvedAmount *
            Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
        )
        if (allowance >= required.toNumber()) {
          clearInterval(check)
          self.approvedStatus = true
          if (self.getAccount.type !== 'metamask')
            self.hideModal('unlock_request_modal_ref')
          self.onSubmit()
        }
        if (!txHash) txHash = self.unlockTxHash
        let isFailed = await self.isTxFailed(txHash)
        if (isFailed) {
          clearInterval(check)
          self.hideModal('unlock_request_modal_ref')
          self.showFailedUnlock(txHash)
        }
      }, 2000)
    },
    async updateUsdAmount () {
      let inputAmount = this.form.inputValue
      if (!this.validateinputValue) {
        return
      }
      if (this.form.inputCurrency === 'ETH') {
        let updatedUsdValue = parseFloat(inputAmount * this.ethToUsd)
        let shouldUpdate =
          Math.abs(updatedUsdValue - this.form.inputValueUsd) > 0.01
            ? true
            : false

        if (shouldUpdate) this.form.inputValueUsd = updatedUsdValue
      } else {
        let tokenToUsd = this.getPrice[this.form.inputTokenAddress]
        let updatedUsdValue = parseFloat(inputAmount * tokenToUsd)
        let shouldUpdate =
          Math.abs(updatedUsdValue - this.form.inputValueUsd) > 0.01
            ? true
            : false

        if (shouldUpdate) this.form.inputValueUsd = updatedUsdValue
      }
    },
    async showSignInModal () {
      let self = this
      this.showModal('connect_modal_ref')
      this.connectChecker = setInterval(() => {
        console.log('checking...account connection')
        if (self.getAccount) {
          console.log('Account detected, Hiding connect modal')
          self.hideConnectModal()
        }
      }, 1000)
    },
    hideConnectModal () {
      console.log('Account detected. Hiding Signin Modal')
      try {
        this.hideModal('connect_modal_ref')
        clearInterval(this.connectChecker)
        // this.connectChecker = null;
      } catch (e) {
        console.warn(e)
      }
    },
    switchInputOutput () {
      let tempForm = { ...this.form }

      this.form.inputCurrency = tempForm.outputCurrency
      this.form.inputTokenAddress = tempForm.outputTokenAddress
      this.form.inputValue = tempForm.outputValue
      this.form.outputCurrency = tempForm.inputCurrency
      this.form.outputTokenAddress = tempForm.inputTokenAddress
      this.form.outputValue = tempForm.inputValue

      this.lastEditedField = 'input'
      this.onAmountChange()
    },
    async onSubmit (evt) {
      console.log(`Preparing to submit swap tx:`)
      let self = this
      if (!this.getConnection) {
        alert('No Internet Connection Detected !')
        return
      }
      if (!this.getServerStatus) {
        alert('Connection Issue to Server !')
        return
      }
      if (evt) evt.preventDefault()
      this.loading = true
      if (!this.getAccount) {
        console.log('No wallet detected')
        this.showSignInModal()
        return
      }
      let web3 = this.web3
      let inputValue = this.form.inputValue
      let inputCurrency = this.form.inputCurrency
      let inputTokenAddress = this.form.inputTokenAddress
      let outputValue = this.form.outputValue
      let outputCurrency = this.form.outputCurrency
      let outputTokenAddress = this.form.outputTokenAddress
      let recipient = this.form.targetAddress || null
      let ALLOWED_SLIPPAGE = this.ALLOWED_SLIPPAGE
      let type = this.swapType
      let exchangeContract = exchangeContracts[outputCurrency]
      if (this.getAccount.type === 'metamask') {
        try {
          // To check allowance and unlock token if required
          if (inputCurrency !== 'ETH') {
            const allowance = await this.getAllowance(
              this.form.inputCurrency,
              this.form.inputTokenAddress
            )
            const input =
              inputValue *
              Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            console.log(`Current token allowance is: ${allowance}`)
            if (input > allowance) {
              this.loading = false
              this.approvedStatus = false
              this.form.approvedAmount = this.form.inputValue * 1.5
              if (
                this.form.approvedAmount >
                this.getBalance[this.form.inputCurrency]
              ) {
                this.form.approvedAmount = this.getBalance[
                  this.form.inputCurrency
                ]
              }
              this.showModal('unlock_request_modal_ref')
              return
            }
          }

          // submit tx
          this.txHash = await metamaskSwap({
            inputValue,
            inputDecimal: this.getDecimal(this.form.inputTokenAddress),
            inputCurrency,
            inputTokenAddress,
            outputValue,
            outputDecimal: this.getDecimal(this.form.outputTokenAddress),
            outputCurrency,
            outputTokenAddress,
            gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
            gasLimit: parseInt(this.gasLimit),
            from: self.getAccount.address,
            recipient,
            type,
            exchangeContract,
            ALLOWED_SLIPPAGE
          })
        } catch (e) {
          console.error('Error while trying to submit tx using metamask')
          console.error(e)
        }
        if (this.txHash) {
          this.updateActiveToken(this.form.outputCurrency)
          this.updateActiveTokenAddress(outputTokenAddress)
          this.onReset()
          this.loading = false
          this.hideModal('unlock_request_modal_ref')
          this.showSuccessToast(this.txHash)
        } else {
          this.onReset()
          this.loading = false
          this.hideModal('unlock_request_modal_ref')
          this.showModal('failed_modal_ref')
          return
        }
      } else {
        try {
          const block = await getLatestBlock(web3)
          const deadline = block.timestamp + 300
          const accounts = await web3.eth.getAccounts()
          let exchangeContract
          if (type === 'ETH_TO_TOKEN') {
            exchangeContract = exchangeContracts[outputCurrency]
            const contractAddress = this.getAvailableExchangeAddresses[
              this.form.outputTokenAddress
            ]
            console.log(this.form)
            console.log('ETH to token')
            let minimumTokenBought = new BigNumber(outputValue)
              .multipliedBy(1 - ALLOWED_SLIPPAGE)
              .multipliedBy(10 ** this.getDecimal(this.form.outputTokenAddress))
              .toFixed(0)
            console.log(minimumTokenBought)
            const ethSold = new BigNumber(
              inputValue * Math.pow(10, 18)
            ).toFixed(0)
            await this.updateGasLimitAndTxFee()
            console.log({
              from: this.getAccount.address,
              ethSold: ethSold,
              gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
              gasLimit: parseInt(this.gasLimit),
              minimumTokenBought,
              deadline
            })
            try {
              this.txHash = await swapEthToToken(
                {
                  from: this.getAccount.address,
                  ethSold: ethSold,
                  gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
                  gasLimit: parseInt(this.gasLimit),
                  minimumTokenBought,
                  deadline,
                  recipient
                },
                exchangeContract,
                contractAddress,
                this.getAccount.privateKey,
                this.web3
              )
            } catch (e) {
              console.log(e)
              console.log('error occoured while swapping...')
            }
            if (this.txHash) console.log(this.txHash)
            if (!this.txHash) {
              this.loading = false
              this.showModal('failed_modal_ref')
              return
            }
            this.updateActiveToken(this.form.outputCurrency)
            this.updateActiveTokenAddress(this.form.outputTokenAddress)
            this.onReset()
            this.loading = false
            this.showSuccessToast(this.txHash)
          } else if (type === 'TOKEN_TO_ETH') {
            exchangeContract = exchangeContracts[inputCurrency]
            const tokenSold = new BigNumber(
              inputValue *
                Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            ).toFixed(0)
            const exchangeRate = parseFloat(outputValue / inputValue)
            let minEth = new BigNumber(outputValue)
              .multipliedBy(1 - ALLOWED_SLIPPAGE)
              .multipliedBy(10 ** 18)
              .toFixed(0)
            if (minEth <= 0) {
              minEth = new BigNumber(outputValue)
                .multipliedBy(0.9)
                .multipliedBy(10 ** 18)
                .toFixed(0)
            }
            const contractAddress = this.getAvailableExchangeAddresses[
              this.form.inputTokenAddress
            ]
            await this.updateGasLimitAndTxFee()
            const allowance = await this.getAllowance(
              this.form.inputCurrency,
              this.form.inputTokenAddress
            )
            const input =
              this.form.inputValue *
              Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            console.log(`Current token allowance is: ${allowance}`)
            if (input > allowance) {
              this.loading = false
              this.approvedStatus = false
              this.form.approvedAmount = this.form.inputValue * 1.5
              if (
                this.form.approvedAmount >
                this.getBalance[this.form.inputCurrency]
              ) {
                this.form.approvedAmount = this.getBalance[
                  this.form.inputCurrency
                ]
              }
              this.showModal('unlock_request_modal_ref')
              return
            }
            console.log({
              from: this.getAccount.address,
              amount:
                parseFloat(this.form.inputValue) *
                Math.pow(10, this.getDecimal(this.form.inputTokenAddress)),
              gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
              gasLimit: parseInt(this.gasLimit),
              tokenSold,
              minEth,
              deadline
            })
            this.txHash = await swapTokenToEth(
              {
                from: this.getAccount.address,
                amount:
                  parseFloat(this.form.inputValue) *
                  Math.pow(10, this.getDecimal(this.form.inputTokenAddress)),
                gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
                gasLimit: parseInt(this.gasLimit),
                tokenSold,
                minEth,
                deadline,
                recipient
              },
              exchangeContract,
              contractAddress,
              this.getAccount.privateKey,
              this.web3
            )
            this.updateActiveToken(this.form.outputCurrency)
            this.updateActiveTokenAddress(outputTokenAddress)
            this.onReset()
            this.loading = false
            // this.showModal("success_modal_ref");
            this.showSuccessToast(this.txHash)
          } else if (type === 'TOKEN_TO_TOKEN') {
            exchangeContract = exchangeContracts[inputCurrency]
            const contractAddress = this.getAvailableExchangeAddresses[
              this.form.inputTokenAddress
            ]
            const tokenASold = new BigNumber(
              inputValue *
                Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            ).toFixed(0)
            const minTokenBBought = new BigNumber(1).toFixed(0)
            console.log(`Minimum token bought is ${minTokenBBought}`)
            const minEth = new BigNumber(1).toFixed(0)
            const outputTokenAddress = tokenAddressess[outputCurrency]
            await this.updateGasLimitAndTxFee()
            // check allowance value for input token
            const allowance = await this.getAllowance(
              this.form.inputCurrency,
              this.form.inputTokenAddress
            )
            const input =
              this.form.inputValue *
              Math.pow(10, this.getDecimal(this.form.inputTokenAddress))
            console.log(`${inputCurrency} token allowance is: ${allowance}`)
            if (input > allowance) {
              this.loading = false
              this.approvedStatus = false
              this.form.approvedAmount = this.form.inputValue * 1.5
              if (
                this.form.approvedAmount >
                this.getBalance[this.form.inputCurrency]
              ) {
                this.form.approvedAmount = this.getBalance[
                  this.form.inputCurrency
                ]
              }
              this.showModal('unlock_request_modal_ref')
              return
            }
            console.log({
              from: this.getAccount.address,
              gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
              gasLimit: parseInt(this.gasLimit),
              tokenASold,
              minEth,
              minTokenBBought,
              deadline,
              outputTokenAddress
            })
            this.txHash = await swapTokenToToken(
              {
                from: this.getAccount.address,
                gasPrice: parseInt(this.gasPrice * Math.pow(10, 9)),
                gasLimit: parseInt(this.gasLimit),
                tokenASold,
                minEth,
                minTokenBBought,
                deadline,
                outputTokenAddress,
                recipient
              },
              exchangeContract,
              contractAddress,
              this.getAccount.privateKey,
              this.web3
            )
            this.updateActiveToken(this.form.outputCurrency)
            this.updateActiveTokenAddress(outputTokenAddress)
            this.onReset()
            this.loading = false
            this.showSuccessToast(this.txHash)
          }
        } catch (e) {
          console.log(e)
          this.loading = false
          this.showModal('failed_model_ref')
        }
      }
    },
    async onListToken (e) {
      e.preventDefault()
      this.loading = true
      if (!this.getSignIn) {
        this.resetMessages()
        this.errorMessage = `Please sign into wallet to create a new exchange`
        this.listForm.tokenAddress = ''
        this.loading = false
        return
      }
      let tokenAddress = this.listForm.tokenAddress.toLowerCase()
      if (!tokenAddress) {
        this.loading = false
        this.errorMessage = 'Invalid token address'
        return
      }
      let badToken = this.getBadTokenList.find(
        t => t.tokenAddress.toLowerCase() === tokenAddress.toLowerCase()
      )
      if (badToken) {
        this.resetMessages()
        this.errorMessage = ` Warning not all tokens will work with Uniswap. Read
          <a target="_blank" href="https://www.reddit.com/r/UniSwap/comments/c0k63p/contract_not_working/"
          >this</a> and make sure that your token contract is compatible with Uniswap.`
        this.listForm.tokenAddress = ''
        this.loading = false
        return
      }
      let exchangeAddress = await getExchangeAddress(tokenAddress)
      if (!exchangeAddress) {
        this.resetMessages()
        this.errorMessage = `Invalid Token Address. Failed to calculate exchange address from provided token address!`
        this.listForm.tokenAddress = ''
        this.loading = false
        return
      }
      try {
        if (
          exchangeAddress &&
          exchangeAddress !== '0x0000000000000000000000000000000000000000'
        ) {
          console.log(
            `Exchange address already existed for ${this.listForm.selectedTokenToList.title} token`
          )
          this.resetMessages()
          this.errorMessage = `Exchange address (${exchangeAddress}) already existed for ${this.listForm.selectedTokenToList.title}`
          this.listForm.tokenAddress = ''
          this.loading = false
        } else if (
          exchangeAddress === '0x0000000000000000000000000000000000000000'
        ) {
          let accountType = this.getAccount.type
          if (accountType === 'metamask') {
            this.resetMessages()
            this.infoMessage =
              'Please confirm your transaction on Metamask Wallet.'
            this.txHash = await metamaskCreateNewExchange(
              {
                from: this.getAccount.address
              },
              tokenAddress
            )
          } else {
            this.txHash = await createNewExchange(
              {
                from: this.getAccount.address
              },
              tokenAddress,
              this.getAccount.privateKey,
              this.web3
            )
          }
          this.listForm.tokenAddress = ''
          this.loading = false
          if (this.txHash) {
            this.hideModal('list_token_modal')
            this.showModal('success_modal_ref')
          }
        } else {
          this.loading = false
          console.log('Invalid token address')
          this.resetMessages()
          this.errorMessage = 'Invalid Token Address'
          return
        }
      } catch (e) {
        this.loading = false
        this.resetMessages()
        this.errorMessage = `Unexpected error while trying to create exchange!`
        console.log(e)
      }
    },
    async isTxFailed (txHash) {
      let url = `https://api.etherscan.io/api?module=transaction&action=getstatus&txhash=${txHash}&apikey=${config.etherscanApiKey}`
      let response = await queryServer(url)
      if (response.data.result.isError == '1') return true
      return false
    },
    async showFailedUnlock (txHash) {
      // cancel allowance checker after 5min
      this.failedErrorMessage = `The swap transaction was canceled since the approval transaction has failed on Ethereum network ! Please see transaction detail on <a href="https://etherscan.io/tx/${txHash}" target="_blank">etherscan.io</a>`
      this.showModal('failed_model_ref')
    },
    async getAllowance (inputCurrency, tokenAddress) {
      try {
        let exchangeAddress = this.getAvailableExchangeAddresses[
          tokenAddress.toLowerCase()
        ]
        let token = this.getAvailableTokenList.find(
          t =>
            t.symbol === inputCurrency &&
            t.tokenAddress.toLowerCase() === tokenAddress.toLowerCase()
        )
        const accounts = await this.web3.eth.getAccounts()
        const contract = new this.web3.eth.Contract(ERC20_ABI, tokenAddress)
        // let exchangeContract = exchangeContracts[tokenAddress];
        let address = this.getAccount.address
        let allowance = await contract.methods
          .allowance(address, exchangeAddress)
          .call()
        console.log(
          `Allowance for ${inputCurrency}, ${tokenAddress} is ${allowance}`
        )
        return allowance
      } catch (e) {
        console.log(e)
        console.log('Cannot get token allowance value !')
      }
    },
    onReset (evt) {
      console.log('resetting...')
      if (evt) evt.preventDefault()
      this.form.inputCurrency = null
      this.form.outputCurrency = null
      this.form.inputValue = ''
      this.form.outputValue = ''
      if (this.swapMode === 'donation_swap') this.prepareForDonationSwap()
      this.loading = false
    },
    showModal (ref) {
      if (this.$refs[ref]) this.$refs[ref].show()
    },
    hideModal (ref) {
      this.$refs[ref].hide()
    },
    async updateExchangeRateAndSlippage () {
      console.log('updating exchange rate...')
      let { inputCurrency, outputCurrency, inputValue, outputValue } = this.form
      inputValue = parseFloat(inputValue)
      outputValue = parseFloat(outputValue)
      let web3 = this.web3
      if (inputCurrency !== 'ETH') {
        // token_to_token
        if (outputCurrency !== 'ETH') {
          try {
            let tokenExchangeAddressA = this.getAvailableExchangeAddresses[
              this.form.inputTokenAddress
            ]
            let tokenContractA = tokenContracts[this.form.inputTokenAddress]
            let ethReserveA = await web3.eth.getBalance(tokenExchangeAddressA)
            let tokenRserveA = await tokenContractA.methods
              .balanceOf(tokenExchangeAddressA)
              .call()
            ethReserveA = new BigNumber(ethReserveA)
            tokenRserveA = new BigNumber(tokenRserveA)

            ethReserveA = ethReserveA.dividedBy(10 ** 18)
            tokenRserveA = tokenRserveA.dividedBy(
              10 ** this.getDecimal(this.form.inputTokenAddress)
            )
            let absPriceA = tokenRserveA.dividedBy(ethReserveA)
            let tokenExchangeAddressB = this.getAvailableExchangeAddresses[
              this.form.outputTokenAddress
            ]
            let tokenContractB = tokenContracts[this.form.outputTokenAddress]
            let ethReserveB = await web3.eth.getBalance(tokenExchangeAddressB)
            let tokenReserveB = await tokenContractB.methods
              .balanceOf(tokenExchangeAddressB)
              .call()
            ethReserveB = new BigNumber(ethReserveB)
            tokenReserveB = new BigNumber(tokenReserveB)

            ethReserveB = ethReserveB.dividedBy(10 ** 18)
            tokenReserveB = tokenReserveB.dividedBy(
              10 ** this.getDecimal(this.form.outputTokenAddress)
            )
            let absPriceB = tokenReserveB.dividedBy(ethReserveB)
            let absPrice = absPriceB.dividedBy(absPriceA)
            absPrice = absPrice.toFixed(8)
            this.exchangeRate = outputValue / inputValue
            this.slippage =
              (100 * Math.abs(absPrice - this.exchangeRate)) / absPrice
          } catch (e) {
            // console.log("an error");
          }
        } else if (outputCurrency === 'ETH') {
          // token_to_eth
          let absPrice = await this.calculateAbsPrice(
            inputCurrency,
            this.form.inputTokenAddress
          )
          this.exchangeRate = outputValue / inputValue
          this.slippage =
            (100 * Math.abs(absPrice - this.exchangeRate)) / absPrice
        }
      } else if (inputCurrency === 'ETH' && outputCurrency !== 'ETH') {
        // eth_to_token
        let absPrice = await this.calculateAbsPrice(
          outputCurrency,
          this.form.outputTokenAddress
        )
        this.exchangeRate = outputValue / inputValue

        this.slippage =
          (100 * Math.abs(absPrice - 1 / this.exchangeRate)) / absPrice
      }
    }
  }
}
</script>

<style>
.swaptoken-view {
  min-height: 100vh;
}
#general-swap-section h4 {
  text-align: center;
  margin-bottom: 30px;
}
#general-swap-section {
  padding-top: 0px;
  width: 90%;
  max-width: 560px;
  margin: 0 auto;
  font-size: 13px;
}
#general-swap-section .switch-input-output-icon {
  color: #a41ee4;
  cursor: pointer;
}
#general-swap-section .message-in-swap-form {
  font-size: 13px;
  margin-top: 10px;
}
.submit-button-group {
  display: flex;
  justify-content: space-between;
}
#general-swap-section form button {
  flex-grow: 1;
  margin: 20px 5px;
}
#general-swap-section form button:hover {
  color: #fff;
}
#unlock_request_modal {
  position: fixed;
  top: 150px;
}
#general-swap-section form label {
  font-weight: bolder;
  font-size: 13px;
  text-align: left;
  width: 100%;
  margin-bottom: 10px;
  height: auto;
}
#general-swap-section form {
  margin-bottom: 10px;
  margin-top: 0px;
}
#general-swap-section .input-form-group {
  height: 80px;
  margin-bottom: 0px;
}
#general-swap-section .output-group-container,
#general-swap-section .input-group-container {
  background: #f9f9f9;
  padding: 20px;
  adding-bottom: 5px;
  margin: 20px auto;
  border-radius: 10px;
  box-shadow: 0px 3px 6px #cdcdcd;
}
.v-select {
  height: 40px;
  background: #fff;
}
.vs--searchable .vs__dropdown-toggle {
  cursor: text;
  height: 40px;
}
#unlock_request_modal button[type='submit'] {
  width: 100%;
}
#unlock_request_modal .modal-body p {
  font-size: 13px;
  line-height: 1.5;
}
#success_modal .modal-header {
  border-radius: 0px !important;
  border: none;
  z-index: 666;
  position: relative !important;
  height: 62px !important;
}
#success_modal .modal-body p {
  font-size: 13px;
  line-height: 1.5;
}
#currency-swap-button svg {
  transform: rotateZ(90deg);
}
#currency-swap-button {
  border-radius: 100px !important;
  width: 50px;
  height: 50px;
  display: block;
  margin: 20px auto !important;
}
.exchange-info-container {
  display: flex;
  justify-content: space-between;
}
.exchange-info-container p {
  font-size: 13px;
  color: #223b48;
}
.no-exchange-yet p {
  text-align: center;
  margin: 30px auto;
  line-height: 1.5;
}
.buy-or-sell .switch-buy,
.buy-or-sell .switch-sell {
  width: 170px;
  height: 50px;
  font-size: 13px;
  outline: none;
  border: none;
  background: #bbc1c3;
  color: #333;
}
.buy-or-sell .switch-buy:hover,
.buy-or-sell .switch-sell:hover {
  outline: none;
  border: none;
  background: #aaa;
}
.buy-or-sell .switch-buy:focus,
.buy-or-sell .switch-sell:focus {
  outline: none;
  border: none;
  box-shadow: none;
}
.buy-or-sell .selected,
.buy-or-sell .selected:hover {
  background: #773794;
  color: #fff;
  font-weight: bold;
}
.qr-scanner-container {
  display: flex;
  justify-content: center;
  background: #333;
}
.qr-scanner-container,
.qrcode-stream {
  height: calc(100vh - 64px);
  width: 100%;
}
.qrcode-stream__inner-wrapper {
  height: 100vh;
  width: 100%;
  margin: 0 auto;
}
.qrcode-stream__camera,
.qrcode-stream__pause-frame {
  width: 100%;
  height: calc(100vh);
}
.cancel-scanner-btn {
  bottom: 100px;
  width: 110px;
  height: 50px;
  position: fixed;
}
.camera-error-message {
  position: fixed;
  top: 160px;
  z-index: 1000;
  color: #e61209;
  font-weight: bolder;
}
.advanced-toggle-group {
  height: auto !important;
  padding-top: 5px;
}
.reset-gas-price {
  color: #3571ad;
  cursor: pointer;
  text-align: right !important;
  width: 160px;
  margin-bottom: 10px;
}
#bad-token-message {
  font-size: 13px;
  text-align: left;
  line-height: 1.5;
  color: #ff5722;
}
@media screen and (max-width: 500px) {
  form label {
    font-size: 12px;
  }
  .amount-label-container .current-balance {
    font-size: 11px;
    margin-bottom: 5px;
  }
}
</style>
